;-----------------------------------------------------------------------------
; Structures
;-----------------------------------------------------------------------------
    INT_Desc		STRUC
	IGate_Offset	dw	?	; Offset of handler
	CSEG_Sel	dw	?	; Code segment selector
			db	0
			db	8Eh	; 386 interrupt gate=32bit CS:EIP EFLAGS
	Resvd		dw	0	; Reserved=0
    INT_Desc		ENDS


    Descriptor  STRUC
	Seg_limit       dw      ?       ; Segment limit
	Base_A15_A00    dw      ?       ; A00..A15 of base address
	Base_A23_A16    db      ?       ; A16..A23 of base address
	Access_rights   db      ?       ; Segment access rights
	GDLimit_A19_A16 db      ?       ; Granularity, Op-size, Limit A16..A19
	Base_A31_A24    db      ?       ; A24..A31 of base address
    Descriptor  ENDS


    Desc_cache  STRUC
	_Limit  dd      ?
	_Addr   dd      ?
	_Type   dd      ?
    Desc_cache  ENDS

    TSS_Struct  STRUCT
	TSS_Link        dd      ?
	TSS_ESP0        dd      ?
	TSS_SS0         dd      ?
	TSS_ESP1        dd      ?
	TSS_SS1         dd      ?
	TSS_ESP2        dd      ?
	TSS_SS2         dd      ?
	TSS_CR3         dd      ?
	TSS_EIP         dd      ?
	TSS_EFLAGS      dd      ?
	TSS_EAX         dd      ?
	TSS_ECX         dd      ?
	TSS_EDX         dd      ?
	TSS_EBX         dd      ?
	TSS_ESP         dd      ?
	TSS_EBP         dd      ?
	TSS_ESI         dd      ?
	TSS_EDI         dd      ?
	TSS_ES          dd      ?
	TSS_CS          dd      ?
	TSS_SS          dd      ?
	TSS_DS          dd      ?
	TSS_FS          dd      ?
	TSS_GS          dd      ?
	TSS_LDTR        dd      ?
	TSS_T_IOMAP     dd      ?
    TSS_Struct  ENDS


    v86_Context STRUCT
	v86ErrorCode	dd	?
	v86EIP		dd	?
	v86CS		dd	?
	v86EFLAGS	dd	?
	v86ESP		dd	?
	v86SS		dd	?
	v86ES		dd	?
	v86DS		dd	?
	v86FS		dd	?
	v86GS		dd	?
    v86_Context ENDS
